package tree.data;

import tree.model.*;

public class OperationFactory {

	public static Operation create(char type, Tree leftOperand, Tree rightOperand) throws UnknownOperationException {
		switch (type) {
		case '+':
			return new Addition(leftOperand, rightOperand);
		case '-':
			return new Subtraction(leftOperand, rightOperand);
		case '*':
			return new Multiplication(leftOperand, rightOperand);
		default:
			throw new UnknownOperationException(type);
		}
	}
}
