package tree.model;

import tree.engine.TreeVisitor;

public class Addition extends Operation {

	public Addition(Tree left, Tree right) {
		super(left, right);
	}

	@Override
	public String toString() {
		return getLeft().toString() + " + " + getRight().toString();
	}

	@Override
	public <T> T accept(TreeVisitor<T> visitor) {
		return visitor.visit(this);
	}

	@Override
	public int calculate() {
		return getLeft().calculate() + getRight().calculate();
	}

}
