package tree.model;

import tree.engine.TreeVisitor;

public interface Tree {
	Tree getLeft();

	Tree getRight();
	
	/**
	 * Interpreter pattern for calculating the tree (formula).
	 * 
	 * @return the result of the calculation. 
	 */
	int calculate();

	<T> T accept(TreeVisitor<T> visitor);
}
