package tree.model;

import tree.data.OperandFactory;
import tree.engine.TreeVisitor;

public class Variable extends Operand {
	private String name;

	public Variable(String name) {
		this.name = name;
	}

	public String getName() {
		return name;
	}

	@Override
	public String toString() {
		return name;
	}

	@Override
	public <T> T accept(TreeVisitor<T> visitor) {
		return visitor.visit(this);
	}
	
	@Override
	public int calculate() {
		OperandFactory operandFactory = OperandFactory.getInstance();
		return operandFactory.getVariableValue(name);
	}

}
